/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-clearpath-base-0.4.4-0precise-20150328-1036/msg/ClearpathRobot.msg
 *
 */


#ifndef CLEARPATH_BASE_MESSAGE_CLEARPATHROBOT_H
#define CLEARPATH_BASE_MESSAGE_CLEARPATHROBOT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace clearpath_base
{
template <class ContainerAllocator>
struct ClearpathRobot_
{
  typedef ClearpathRobot_<ContainerAllocator> Type;

  ClearpathRobot_()
    : name()
    , model()
    , platform_revision(0)
    , serial(0)
    , horizon_version()
    , firmware_version()
    , firmware_revision(0)
    , write_date()  {
      horizon_version.assign(0);

      firmware_version.assign(0);
  }
  ClearpathRobot_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , model(_alloc)
    , platform_revision(0)
    , serial(0)
    , horizon_version()
    , firmware_version()
    , firmware_revision(0)
    , write_date(_alloc)  {
      horizon_version.assign(0);

      firmware_version.assign(0);
  }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _model_type;
  _model_type model;

   typedef int32_t _platform_revision_type;
  _platform_revision_type platform_revision;

   typedef uint32_t _serial_type;
  _serial_type serial;

   typedef boost::array<int32_t, 2>  _horizon_version_type;
  _horizon_version_type horizon_version;

   typedef boost::array<int32_t, 2>  _firmware_version_type;
  _firmware_version_type firmware_version;

   typedef int32_t _firmware_revision_type;
  _firmware_revision_type firmware_revision;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _write_date_type;
  _write_date_type write_date;




  typedef boost::shared_ptr< ::clearpath_base::ClearpathRobot_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::clearpath_base::ClearpathRobot_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ClearpathRobot_

typedef ::clearpath_base::ClearpathRobot_<std::allocator<void> > ClearpathRobot;

typedef boost::shared_ptr< ::clearpath_base::ClearpathRobot > ClearpathRobotPtr;
typedef boost::shared_ptr< ::clearpath_base::ClearpathRobot const> ClearpathRobotConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::clearpath_base::ClearpathRobot_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace clearpath_base

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'clearpath_base': ['/tmp/buildd/ros-hydro-clearpath-base-0.4.4-0precise-20150328-1036/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::clearpath_base::ClearpathRobot_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::clearpath_base::ClearpathRobot_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::clearpath_base::ClearpathRobot_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1bdab2b789676c1b350ab6739da650c7";
  }

  static const char* value(const ::clearpath_base::ClearpathRobot_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1bdab2b789676c1bULL;
  static const uint64_t static_value2 = 0x350ab6739da650c7ULL;
};

template<class ContainerAllocator>
struct DataType< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
{
  static const char* value()
  {
    return "clearpath_base/ClearpathRobot";
  }

  static const char* value(const ::clearpath_base::ClearpathRobot_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string name\n\
string model\n\
int32 platform_revision\n\
uint32 serial\n\
int32[2] horizon_version\n\
int32[2] firmware_version\n\
int32 firmware_revision\n\
string write_date\n\
";
  }

  static const char* value(const ::clearpath_base::ClearpathRobot_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.model);
      stream.next(m.platform_revision);
      stream.next(m.serial);
      stream.next(m.horizon_version);
      stream.next(m.firmware_version);
      stream.next(m.firmware_revision);
      stream.next(m.write_date);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ClearpathRobot_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::clearpath_base::ClearpathRobot_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::clearpath_base::ClearpathRobot_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "model: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.model);
    s << indent << "platform_revision: ";
    Printer<int32_t>::stream(s, indent + "  ", v.platform_revision);
    s << indent << "serial: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.serial);
    s << indent << "horizon_version[]" << std::endl;
    for (size_t i = 0; i < v.horizon_version.size(); ++i)
    {
      s << indent << "  horizon_version[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.horizon_version[i]);
    }
    s << indent << "firmware_version[]" << std::endl;
    for (size_t i = 0; i < v.firmware_version.size(); ++i)
    {
      s << indent << "  firmware_version[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.firmware_version[i]);
    }
    s << indent << "firmware_revision: ";
    Printer<int32_t>::stream(s, indent + "  ", v.firmware_revision);
    s << indent << "write_date: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.write_date);
  }
};

} // namespace message_operations
} // namespace ros

#endif // CLEARPATH_BASE_MESSAGE_CLEARPATHROBOT_H
