/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-clearpath-base-0.4.4-0precise-20150328-1036/msg/PowerSource.msg
 *
 */


#ifndef CLEARPATH_BASE_MESSAGE_POWERSOURCE_H
#define CLEARPATH_BASE_MESSAGE_POWERSOURCE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace clearpath_base
{
template <class ContainerAllocator>
struct PowerSource_
{
  typedef PowerSource_<ContainerAllocator> Type;

  PowerSource_()
    : charge(0.0)
    , capacity(0)
    , present(false)
    , in_use(false)
    , description(0)  {
    }
  PowerSource_(const ContainerAllocator& _alloc)
    : charge(0.0)
    , capacity(0)
    , present(false)
    , in_use(false)
    , description(0)  {
    }



   typedef float _charge_type;
  _charge_type charge;

   typedef int16_t _capacity_type;
  _capacity_type capacity;

   typedef uint8_t _present_type;
  _present_type present;

   typedef uint8_t _in_use_type;
  _in_use_type in_use;

   typedef uint8_t _description_type;
  _description_type description;




  typedef boost::shared_ptr< ::clearpath_base::PowerSource_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::clearpath_base::PowerSource_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PowerSource_

typedef ::clearpath_base::PowerSource_<std::allocator<void> > PowerSource;

typedef boost::shared_ptr< ::clearpath_base::PowerSource > PowerSourcePtr;
typedef boost::shared_ptr< ::clearpath_base::PowerSource const> PowerSourceConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::clearpath_base::PowerSource_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::clearpath_base::PowerSource_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace clearpath_base

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'clearpath_base': ['/tmp/buildd/ros-hydro-clearpath-base-0.4.4-0precise-20150328-1036/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::clearpath_base::PowerSource_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::clearpath_base::PowerSource_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::clearpath_base::PowerSource_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::clearpath_base::PowerSource_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::clearpath_base::PowerSource_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::clearpath_base::PowerSource_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::clearpath_base::PowerSource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "adbe384d7d69a337a7f2b6bf1d0139cb";
  }

  static const char* value(const ::clearpath_base::PowerSource_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xadbe384d7d69a337ULL;
  static const uint64_t static_value2 = 0xa7f2b6bf1d0139cbULL;
};

template<class ContainerAllocator>
struct DataType< ::clearpath_base::PowerSource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "clearpath_base/PowerSource";
  }

  static const char* value(const ::clearpath_base::PowerSource_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::clearpath_base::PowerSource_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float32 charge\n\
int16 capacity\n\
bool present\n\
bool in_use\n\
uint8 description\n\
";
  }

  static const char* value(const ::clearpath_base::PowerSource_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::clearpath_base::PowerSource_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.charge);
      stream.next(m.capacity);
      stream.next(m.present);
      stream.next(m.in_use);
      stream.next(m.description);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PowerSource_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::clearpath_base::PowerSource_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::clearpath_base::PowerSource_<ContainerAllocator>& v)
  {
    s << indent << "charge: ";
    Printer<float>::stream(s, indent + "  ", v.charge);
    s << indent << "capacity: ";
    Printer<int16_t>::stream(s, indent + "  ", v.capacity);
    s << indent << "present: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.present);
    s << indent << "in_use: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.in_use);
    s << indent << "description: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.description);
  }
};

} // namespace message_operations
} // namespace ros

#endif // CLEARPATH_BASE_MESSAGE_POWERSOURCE_H
